#ifndef __creaImageIODicomDatabaseStructure_h_INCLUDED__
#define __creaImageIODicomDatabaseStructure_h_INCLUDED__

#include <creaImageIODicomNode.h>

namespace creaImageIO
{

  struct DicomDatabaseStructure
  {
    /// The minimum DicomNode::Type value. Used to iterate over tables
    static int TableBegin();
	/// The maximum DicomNode::Type value. Used to iterate over tables
	static int TableEnd();
    /// Returns the name of the SQL table associated to a certain DicomNode::Type 
	static const char* Table(DicomNode::Type);
    
    static int NbMandatoryFields(DicomNode::Type);
    static const Field::Description& MandatoryField(DicomNode::Type,int);

    static int NbDefaultFields(DicomNode::Type);
    static const Field::Description& DefaultField(DicomNode::Type,int);

    static int NbQueryFields(DicomNode::Type);
    static const Field::Description& QueryField(DicomNode::Type,int);
  };


} // namespace creaImageIO

#endif // #ifndef __creaImageIODicomDatabaseStructure_h_INCLUDED__
