#include <creaImageIOWxGimmickDialog.h>
#include <creaImageIOImageReader.h>

namespace creaImageIO
{

  //================================================================
  WxGimmickDialog::WxGimmickDialog()
  {
  }
  //================================================================
  
  //================================================================
  WxGimmickDialog::WxGimmickDialog(wxWindow *parent, 
				   wxWindowID id,
				   wxString title,
				   const wxPoint& pos,
				   const wxSize& size,
				   int image_type,
				   int threads)
    :   wxDialog( parent, 
		  id, 
		  title,
		  pos,
		  size,
		  wxRESIZE_BORDER | 
		  wxSYSTEM_MENU  |
		  wxCLOSE_BOX |
		  wxMAXIMIZE_BOX | 
		  wxMINIMIZE_BOX | 
		  wxCAPTION  
		  )
  {
    wxBoxSizer *topsizer = new wxBoxSizer(wxVERTICAL);
    
    mView = new ViewType(this,
			 TVID,
			 wxDefaultPosition,
			 size,
			 image_type,
			 threads);
 
    topsizer->Add( mView,1,wxGROW,0);

    wxSizer* bsizer = CreateSeparatedButtonSizer(wxOK|wxCANCEL);
    mOkButton = (wxButton*)FindWindowById(GetAffirmativeId(), this);
    mCancelButton = (wxButton*)FindWindowById(GetEscapeId(), this);
    
    mOkButton->Enable(false);

    topsizer->Add ( bsizer, 0, wxGROW );

    SetSizer( topsizer );     
    Layout(); 
  
  }
  //================================================================

  //================================================================
  WxGimmickDialog::~WxGimmickDialog()
  {
    //	  std::cout <<"WxGimmickDialog::~WxGimmickDialog()"<<std::endl;
  }
  //================================================================

  //================================================================
  void WxGimmickDialog::OnSelChanged(EventType& event)
  {
    //    std::cout << "++++++++++ WxGimmickDialog::OnSelChanged ++++++++++"
  
    if (mView->IsSelectionValid())
      {
	mOkButton->Enable(true);
      }
    else 
      {
	mOkButton->Enable(false);
      }
  }
   //================================================================


 //================================================================
  void WxGimmickDialog::OnContextualMenu(EventType& event)
  {
    //    std::cout << "++++++++++ WxGimmickDialog::OnContextualMenu ++++++++++"
    //	      <<std::endl;
    /*
    event.GetMenu().AppendSeparator();
    event.GetMenu().Append(ViewType::UserMenuFirstId, 
			   wxT("&Test user menu"));
    */
  }
 //================================================================
 

  //================================================================
  void WxGimmickDialog::OnMenuTest(wxCommandEvent& event)
  {
    //    std::cout << "++++++++++ WxGimmickDialog::OnMenuTest ++++++++++"
    //	      <<std::endl;
    wxMessageBox( wxT("WxGimmickDialog : user clicked on 'Test user menu'"),
		  wxT("Test"),
                 wxOK | wxICON_INFORMATION, this);
  }
 //================================================================

  /*
  //================================================================
  void WxGimmickDialog::OnButtonOk(wxCommandEvent& event)
  {
    std::cout << "++++++++++ WxGimmickDialog::OnButtonOk ++++++++++"
	      << std::endl;
    EndModal(wxID_OK);
  }
  //================================================================
  
  
  //================================================================
  void WxGimmickDialog::OnButtonCancel(wxCommandEvent& event)
  {
    std::cout << "++++++++++ WxGimmickDialog::OnButtonCancel ++++++++++"
	      << std::endl;
    EndModal(wxID_CANCEL);
  }
  //================================================================
  */

 //================================================================
  BEGIN_EVENT_TABLE(WxGimmickDialog, wxDialog)
    EVT_TREEVIEWLIST_SEL_CHANGED(TVID,WxGimmickDialog::OnSelChanged)
    EVT_TREEVIEWLIST_CONTEXTUAL_MENU(TVID,WxGimmickDialog::OnContextualMenu)
    EVT_MENU(WxGimmickDialog::ViewType::UserMenuFirstId, 
	     WxGimmickDialog::OnMenuTest)
  //    EVT_BUTTON(OKID, WxGimmickDialog::OnButtonOk )
  //    EVT_BUTTON(CANCELID, WxGimmickDialog::OnButtonCancel )
    END_EVENT_TABLE()
 //================================================================














  //================================================================
} // namespace creaImageIO
