#ifndef __creaImageIODicomImageReader_h_INCLUDED__
#define __creaImageIODicomImageReader_h_INCLUDED__


#include <creaImageIOAbstractImageReader.h>

// forward decl
class vtkGdcmReader;

namespace creaImageIO
{


  /**
   * \ingroup IO
   */
  
  //=====================================================================
  /// Concrete image reader for DICOM images 
  class DicomImageReader : virtual public AbstractImageReader
  {
  public:
    DicomImageReader();
    virtual ~DicomImageReader();

	/// Add file extensions read by the reader
    virtual void PushBackExtensions(std::vector<std::string>&);
	/// Test if file is read by this reader
    virtual bool CanRead(const std::string& filename);
	/// return for a file a 2D VTkImage
    virtual vtkImageData* ReadImage(const std::string& filename);
	/// Read the attributes for a file
    virtual void ReadAttributes(const std::string& filename, 
				tree::AttributeMapType& attr);

  private:
    vtkGdcmReader* mReader;
  };
  //=====================================================================



} // namespace creaImageIO



#endif // #ifndef __creaImageIODicomImageReader_h_INCLUDED__
