#include <creaImageIOGimmickReaderDialog.h>
#include <creaImageIOWxGimmickReaderDialog.h>
#include <BlockScopeWxApp.h>

namespace creaImageIO
{

  bool GimmickReaderDialog(std::vector<vtkImageData*>& images,
			   const std::string& title,
			   int posx, 
			   int posy,
			   int sizex,
			   int sizey,
			   int image_min_type,
			   int image_max_type,
			   int image_out_dim,
			   int nb_threads)
  {
    BlockScopeWxApp app;
    
    creaImageIO::WxGimmickReaderDialog w(0,
					 -1,
					 crea::std2wx(title),
					 wxPoint(posx,posy),
					 wxSize(sizex,sizey),
					 image_min_type,
					 image_max_type,
					 nb_threads);
    w.ShowModal();
    
    if (w.GetReturnCode() == wxID_OK)
      {
	w.GetSelectedImages(images,image_out_dim);
	return true;
      }
    else if (w.GetReturnCode() == wxID_CANCEL)
      {
	return false;
      }
    else 
      {
	std::cout << "!! ERROR : GimmickReaderDialog : dialog ended without return code !"
		  <<std::endl;
	return false;
      }
  
  
  }

}
