#ifndef __creaImageIOGimmickReaderDialog_h_INCLUDED__
#define __creaImageIOGimmickReaderDialog_h_INCLUDED__

#include "creaImageIOSystem.h"
#include <vtkImageData.h>
#include <vector>


namespace creaImageIO
{
  /**
   * \ingroup GUI
   * \brief Pops up a WxGimmickReaderDialog 
   * returns true if the user clicked 'Ok', false if 'Cancel'
   *  and fills the vector of images
   */
  bool CREAIMAGEIO_EXPORT GimmickReaderDialog
  (std::vector<vtkImageData*>& images,
   const std::string& title = "Select images",
   int posx = 0, int posy = 0,
   int sizex = 1200, int sizey = 800,
   int image_min_type = 2,
   int image_max_type = 3,
   int image_out_dim = 2,
   int nb_threads = 1);
  
}

#endif
