#ifndef __creaImageIORFImageReader_h_INCLUDED__
#define __creaImageIORFImageReader_h_INCLUDED__


#include <creaImageIOAbstractImageReader.h>
#include <creaImageIOSystem.h>

namespace creaImageIO
{


  /**
   * \ingroup IO
   */
  
  //=====================================================================
  /// Concrete image reader for ultrasonix 'rf' files
  class CREAIMAGEIO_EXPORT RFImageReader : virtual public AbstractImageReader
  {
  public:
    RFImageReader();

    virtual ~RFImageReader();

    virtual void PushBackExtensions(std::vector<std::string>&);
    virtual bool CanRead(const std::string& filename);
    virtual vtkImageData* ReadImage(const std::string& filename);
    virtual void ReadAttributes(const std::string& filename, 
				tree::AttributeMapType& attr);

  };
  //=====================================================================



} // namespace creaImageIO



#endif // #ifndef __creaImageIORFImageReader_h_INCLUDED__
