#include <boost/program_options.hpp>
#include <map>

#define SETTINGS_DICOM_LIBRARY "<DICOM Library>"
#define SETTINGS_SYNC_EVENT     "<syncro_event>"
#define SETTINGS_SYNC_FREQ       "<syncro_frequency>"
#define SETTINGS_DBPATH       "<dbpath>"
#define SETTINGS_COPY_PATH       "<copy_path>"


namespace creaImageIO
{
    class Settings{
    public :
        Settings(const std::string i_path);
        ~Settings();

        //get the value for a given option
		const std::string getValue(const std::string i_key){return m_SettingsMap[i_key];}
	
		void addDB(const std::string &i_path);

		void removeDB(const std::string &i_path);

		void updateSetting(const std::string& key, const std::string &val);
	
		//write configuration file
		void writeSettingsFile();
		
    private :
		// Settings Key-Value Map
		std::map<std::string, std::string> m_SettingsMap;
		
		//read the configuration file
 		void readSettings(std::vector<std::string> &i_Keys, const std::string &i_file);
        // create the configuration file
        void createFile();
		void writeSettings(std::ofstream &o_filebuf);
		std::string m_SettingsFileName;
		
 		
    };
}
