#ifndef __creaImageIOSystem_INCLUDED__
#define __creaImageIOSystem_INCLUDED__

#include <creaMessageManager.h>

#if defined(_WIN32)
  #ifdef CREAIMAGEIO_EXPORT_SYMBOLS
    #define CREAIMAGEIO_EXPORT __declspec( dllexport )
#else
    #define CREAIMAGEIO_EXPORT __declspec( dllimport )
  #endif
  #define CREAIMAGEIO_CDECL __cdecl
#else
  #define CREAIMAGEIO_EXPORT
  #define CREAIMAGEIO_CDECL
#endif // defined(_WIN32)

namespace creaImageIO
{
  //==============================================================
  inline void RegisterGimmickMessageTypes()
  {
    static bool first_time = true;
    if (first_time)
      {
	crea::MessageManager::RegisterMessageType("Gimmick!",
						  "Gimmick",1);
	crea::MessageManager::RegisterMessageType("Gimmick! DEBUG",
						  "Gimmick",0);
	first_time = false;
      }
  }
  //==============================================================
  inline void SetGimmickMessageLevel(int l)
  {
    RegisterGimmickMessageTypes();			
    crea::MessageManager::SetMessageLevel("Gimmick!",l);
  }
  //==============================================================
  inline void SetGimmickDebugMessageLevel(int l)		
  {
    RegisterGimmickMessageTypes();			
    crea::MessageManager::SetMessageLevel("Gimmick! DEBUG",l);
  }
  //==============================================================
  
#define GimmickMessage(LEV,MESS)			\
  creaMessage("Gimmick!",LEV,"[Gimmick!] "<<MESS);
#define GimmickDebugMessage(LEV,MESS)					\
  creaDebugMessage("Gimmick! DEBUG",LEV,"[Gimmick!] DEBUG: "<<MESS);
#define GimmickError(MESS)			\
  creaError("[Gimmick!] "<<MESS);
  
} // namespace

#endif

