#ifndef __creaImageIOUltrasonixImageReader_h_INCLUDED__
#define __creaImageIOUltrasonixImageReader_h_INCLUDED__


#include <creaImageIOAbstractImageReader.h>
#include <creaImageIOSystem.h>

namespace creaImageIO
{


  /**
   * \ingroup IO
   */
  
  //=====================================================================
  /// Concrete image reader for ultrasonix 'rf' files
  class CREAIMAGEIO_EXPORT UltrasonixImageReader : virtual public AbstractImageReader
  {
  public:
    UltrasonixImageReader();

    virtual ~UltrasonixImageReader();
	/// Add file extensions read by the reader
    virtual void PushBackExtensions(std::vector<std::string>&);
	/// Test if file is read by this reader
    virtual bool CanRead(const std::string& filename);
	/// return for a file a 2D VTkImage
    virtual vtkImageData* ReadImage(const std::string& filename);
	/// Read the attributes for a file
    virtual void ReadAttributes(const std::string& filename, 
				tree::AttributeMapType& attr);


  };
  //=====================================================================



} // namespace creaImageIO



#endif // #ifndef __creaImageIOUltrasonixImageReader_h_INCLUDED__
