#ifndef __creaImageIOVtkImageReader_h_INCLUDED__
#define __creaImageIOVtkImageReader_h_INCLUDED__


#include <creaImageIOAbstractImageReader.h>

// forward decl
class vtkImageReader2;

namespace creaImageIO
{


  /**
   * \ingroup IO
   */
  
  //=====================================================================
  /// Concrete image reader based on a vtkImageReader2 
  class VtkImageReader : virtual public AbstractImageReader
  {
  public:
    VtkImageReader(vtkImageReader2* reader, 
		   const std::string& name = "",
		   const std::string& extensions = "");

    virtual ~VtkImageReader();

	/// Add file extensions read by the reader
    virtual void PushBackExtensions(std::vector<std::string>&);
	/// Test if file is read by this reader
    virtual bool CanRead(const std::string& filename);
	/// return for a file a 2D VTkImage
    virtual vtkImageData* ReadImage(const std::string& filename);
	/// Read the attributes for a file
    virtual void ReadAttributes(const std::string& filename, 
				tree::AttributeMapType& attr);

  private:
    vtkImageReader2* mReader;
    std::string mExtensions;
  };
  //=====================================================================



} // namespace creaImageIO



#endif // #ifndef __creaImageIOVtkImageReader_h_INCLUDED__
