#include <creaImageIOWxCustomizeConfigPanel.h>
#include <creaImageIOSystem.h>

namespace creaImageIO
{
  // CTor
  WxCustomizeConfigPanel::WxCustomizeConfigPanel(wxWindow *parent, wxDialog* dial, WxGimmickView* view, const std::string& cPath, 
		const std::string& dPath,
		const std::string& sEvent,
		const std::string& sFreq)
 :   wxPanel( parent, 
		  -1, wxDefaultPosition, 
		  wxDefaultSize,
		  wxRESIZE_BORDER | 
	      wxSYSTEM_MENU  |
		  wxCLOSE_BOX |
		  wxMAXIMIZE_BOX | 
		  wxMINIMIZE_BOX | 
		  wxCAPTION  
	       ), 	
		   dialog(dial),
		   copyP (cPath), 
		   databaseP(dPath), 
		   syncEv(sEvent), 
		   syncFr(sFreq),
		   mView(view)
  {
    GimmickDebugMessage(1,"WxCustomizeConfigPanel::WxCustomizeConfigPanel"
			<<std::endl);
	wxStaticText * cp=new wxStaticText(this,-1,_T(" Copy Path: "), wxPoint(5,10));
    copyPath=new wxTextCtrl(this, wxID_ANY, crea::std2wx(copyP), wxPoint(150,10), wxSize(250,20));

	wxStaticText * dp=new wxStaticText(this,-1,_T(" Database Path: "), wxPoint(5,40));
	dbPath=new wxTextCtrl(this, wxID_ANY, crea::std2wx(databaseP), wxPoint(150,40), wxSize(250,20));

	wxStaticText * se=new wxStaticText(this,-1,_T(" Synchronization Event: "), wxPoint(5,70));
	syncEvent=new wxTextCtrl(this, wxID_ANY, crea::std2wx(syncEv), wxPoint(150,70), wxSize(250,20));

	wxStaticText * sf=new wxStaticText(this,-1,_T(" Synchronization Frequency: "), wxPoint(5,100));
	syncFrequency=new wxTextCtrl(this, wxID_ANY, crea::std2wx(syncFr), wxPoint(150,100), wxSize(250,20));

	wxButton *save = new wxButton(this,wxID_ANY,_T("Save Changes"), wxPoint(5,130) );
	Connect( save->GetId(), wxEVT_COMMAND_BUTTON_CLICKED , (wxObjectEventFunction) &WxCustomizeConfigPanel::OnSaveConfig ); 
  

    //topsizer->Add( mView,1,wxGROW,0);

//    SetSizer( topsizer );     
    Layout(); 
  }

  /// Destructor
  WxCustomizeConfigPanel::~WxCustomizeConfigPanel()
  {
    GimmickDebugMessage(1,"WxCustomizeConfigPanel::~WxCustomizeConfigPanel"
			<<std::endl);
  }

  void WxCustomizeConfigPanel::OnSaveConfig(wxCommandEvent& event)
  {
	  mView->OnSaveSettingsCallback(crea::wx2std(copyPath->GetValue()),
		  crea::wx2std(dbPath->GetValue()),
		  crea::wx2std(syncEvent->GetValue()),
		  crea::wx2std(syncFrequency->GetValue()));
	  dialog->Destroy();
  }
  
//======================================================================
  
//====================================================================== 

} // EO namespace creaImageIO


